#include <stdio.h>

#define SWAP(x,y) { unsigned char tmp = x; x = y; y = tmp; }


int main( void )
{
    FILE *f_ivs_out;
    int i, j, m, n;
    unsigned char K[16];
    unsigned char S[256];
    unsigned char key[13] = "\x11\xA3\xE2\x29\x08\x43\x49"
                            "\xBC\x25\xD9\x7E\x29\x39";

    if( ( f_ivs_out = fopen( "wep.ivs", "wb+" ) ) == NULL )
    {
        perror( "fopen" );
        return( 1 );
    }

    fprintf( f_ivs_out, "\xBF\xCA\x84\xD4\x01\x01\x01\x01\x01\x01" );

    memcpy( K + 3, key, 13 );

    for( n = 0; n < 500000; n++ )
    {
        K[2] = ( n >> 16 ) & 0xFF;
        K[1] = ( n >>  8 ) & 0xFF;
        K[0] = ( n       ) & 0xFF;

        fprintf( f_ivs_out, "%c%c%c", K[0], K[1], K[2] );

        for( i = 0; i < 256; i++ )
            S[i] = i;

        for( i = j = 0; i < 256; i++ )
        {
            j = ( j + S[i] + K[i & 15] ) & 0xFF;
            SWAP( S[i], S[j] );
        }

        i = 1; j = ( 0 + S[i] ) & 0xFF; SWAP(S[i], S[j]);
        fprintf( f_ivs_out, "%c", 0xAA ^ S[(S[i] + S[j]) & 0xFF] );

        i = 2; j = ( j + S[i] ) & 0xFF; SWAP(S[i], S[j]);
        fprintf( f_ivs_out, "%c\xFF", 0xAA ^ S[(S[i] + S[j]) & 0xFF] );
    }

    fclose( f_ivs_out );
    printf( "Done.\n" );
    return( 0 );
}

